﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Schema;
//MIASOFT LABS. Russia, Volgograd.
namespace testXSD
{
    class Program
    {
        static string resCode = "Test OK!";
        static int exCode = 0;
        static string XMLfile = "Import_2019.xml";
        static string XSDfile = "ReqImport.xsd";
        static void Main(string[] args)
        {
            Console.Title = ("testXSD - validate XML-file by XSD-schema. Contact: www.miasoft.h1n.ru");
            Console.BackgroundColor = ConsoleColor.Blue;
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Clear();
            GetArguments(args);
            Console.WriteLine(" ");
            XmlReaderSettings booksSettings = new XmlReaderSettings();
            //  booksSettings.Schemas.Add("http://www.contoso.com/books", "Books.xsd");
            booksSettings.Schemas.Add(null, XSDfile);
            booksSettings.ValidationType = ValidationType.Schema;
            booksSettings.ValidationEventHandler += new ValidationEventHandler(booksSettingsValidationEventHandler);

            XmlReader books = XmlReader.Create(XMLfile, booksSettings);

            while (books.Read()) { }
            Console.WriteLine(resCode);
            Console.ReadKey();
            Environment.ExitCode = exCode;
            Environment.Exit(Environment.ExitCode);
        }
        static void booksSettingsValidationEventHandler(object sender, ValidationEventArgs e)
        {
            if (e.Severity == XmlSeverityType.Warning)
            {
                Console.Write("WARNING: ");
                Console.WriteLine(e.Message);
                resCode = "Warning!";
                exCode = 200;
            }
            else if (e.Severity == XmlSeverityType.Error)
            {
                Console.Write("ERROR: ");
                Console.WriteLine(e.Message);
                resCode = "Test error!";
                exCode = 400;
            }

            //Console.ReadKey();
        }
        static void GetArguments(string[] myargs)
        {
            if (myargs == null || myargs.Length == 0)  //is arguments?
            {
                Console.Write("Input XML-file name:");
                XMLfile = Console.ReadLine();
                Console.Write("Input XSD-file name:");
                XSDfile = Console.ReadLine();

            }
            else
            {
                foreach (string arg in myargs)
                {
                    if (myargs[0].Length > 0)
                    {
                        XMLfile = myargs[0];
                       // Console.WriteLine(XMLfile);
                    }
                    if (myargs[1].Length > 0)
                    {
                        XSDfile = myargs[1];
                        //Console.WriteLine(XSDfile);
                    }
                   
                }
            }
            Console.WriteLine("Test : " + XMLfile + " by :" + XSDfile);

        }
        //+++++++++++++++++++++
    }
}
